# -*- coding: utf-8 -*-
import pandas as pd
import numpy as np
ipdata= pd.read_csv("C:\Users\ED40024439\Downloads\Melbourne_housing_FULL.csv\Melbourne_housing_FULL.csv")
print('\n')
print('-----------------------------Input Data----------------------------------')
print(ipdata)
print('\n')
print('-------------------------------Describe----------------------------------')
print(ipdata.describe())
print('\n')
print('-------------------------------Shape-------------------------------------')
print(ipdata.shape)
print('\n')
print('-------------------------Numeric Attribute-------------------------------')
print(ipdata._get_numeric_data())
print('\n')
print('------------------------Category Attribute-------------------------------')
print(ipdata.select_dtypes(include=['object']).copy())
print('\n')
#print('-------------------------------NDIM--------------------------------------')
#print(np.ndim(ipdata))

#cleaning
print('\n')
print('-----------------------------Find Duplicates-----------------------------')
#print(np.unique(ipdata))
#m=pd.concat(g for _,g in ipdata.groupby("Suburb")if len(g)>1)
#print(m)
dup=ipdata.duplicated()
print(dup)
#print(sum(dup)-1)
#df=pd.DataFrame(ipdata)
#print(df.duplicated(ipdata))
print('\n')
print('-----------------------------Remove Duplicates-----------------------------')
#print(np.unique(ipdata))
ipdata1=ipdata.drop_duplicates()
print(ipdata1)
print('\n')
print('-----------------------------Number of Rows-------------------------------')
print('Total number of rows before removal of duplicates '+str(ipdata.shape[0]))
print('Total number of rows after removal of duplicates '+str(ipdata1.shape[0]))
print('\n')
print('--------------------------Variable Type-----------------------------')
print(ipdata.info())
print('\n')
print('--------------------------Missing value Treatment-----------------------------')
print(pd.isnull(ipdata1).sum() > 0)
filled=ipdata1.fillna(ipdata1.isnull())
print(filled)
print(ipdata1.isnull().sum())
print('\n')
print('--------------------------Outliers-----------------------------')
subset=pd.DataFrame(filled._get_numeric_data())
print(subset)
for k,v in subset.iteritems():
    a1=subset[k].tolist()
    a = np.array([a1])
    p = np.percentile(a, 50) # return 50th percentile, e.g median.
    print 'percentile value of', subset[k].head(n=0),' is ' ,p
    s = pd.Series([p])
    print 'flooring value of', subset[k].head(n=0),' is ' ,np.floor(s)
    print 'ceiling value of', subset[k].head(n=0),' is ' ,np.ceil(s)
#Rooms      Price  Distance  Postcode  Bedroom2  Bathroom  Car
#  Landsize  BuildingArea  YearBuilt  Lattitude  Longtitude  Propertycount
print('\n')
print('---------------------------Transformation----------------------------')


print('\n')
print('---------------------------Standardization----------------------------')
print('\n')
df=pd.DataFrame(filled)
print('---------------------Mean-----------------------')
print(df.mean())
print('---------------------Median-----------------------')
print(df.median())
print('---------------------Mode-----------------------')
print(df.mode())
print('\n')
print('---------------------------Dummies----------------------------')
#dummies = pd.get_dummies(ipdata['Bedroom2'])
#print(dummies)
#dummies for variable Bedroom2
dummies = pd.get_dummies(ipdata['Bedroom2']).sum()
print(dummies)
dummies1 = pd.get_dummies(ipdata).sum()
print(dummies1)